#! /usr/bin/env node
const { JavaCaller } = require("./java-caller");
const fse = require("fs-extra");

class JavaCallerCli {
    "use strict";

    javaCallerOptions;

    constructor(options) {
        // Use JSON file
        if (typeof options === "string") {
            options = fse.readJSONSync(options);
        }
        // Default output is console with CLI
        if (options.output == null) {
            options.output = "console";
        }
        this.javaCallerOptions = options;
    }

    async process(processArgv, runOptions = {}) {
        const java = new JavaCaller(this.javaCallerOptions);
        const args = [...processArgv];
        args.splice(0, 3);
        const { status } = await java.run(args, runOptions);
        process.exitCode = status;
    }
}

module.exports = { JavaCallerCli };
